package bintools

import kotlinx.serialization.Serializable
import net.sergeych.bintools.JsonPacker
import net.sergeych.bintools.pack
import net.sergeych.bintools.unpack
import kotlin.test.Test
import kotlin.test.assertEquals
import kotlin.test.assertNull

class JsonPackerTest {
    @Serializable
    data class FB1(val foo: Int,val bar: String)
    @Test
    fun testPackUnpack() {
        val mp = JsonPacker()
        println(mp.pack(mapOf("foo" to 42)).decodeToString())
        assertEquals("""{"foo":42}""", mp.pack(mapOf("foo" to 42)).decodeToString())
        val x = mp.unpack<FB1>("""{"foo":42, "bar": "foo"}""".encodeToByteArray())
        println(x)
        assertEquals(42, x.foo)
        assertEquals("foo", x.bar)

        var nx: FB1? = null
        println(mp.pack(nx).decodeToString())
        assertNull(mp.unpack<FB1?>("null".encodeToByteArray()))
    }
}